Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2438 by niro, Tue Jan 7 14:30:19 2014 UTC revision 2654 by niro, Thu Jul 3 08:24:39 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
15    
# Line 39  do Line 40  do
40   fi   fi
41  done  done
42    
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
   
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  # some sane defaults  # some sane defaults
48  CDROOT="${DEFAULT_CDROOT}"  LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
52  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
# Line 70  SPECIALDEVICE="" Line 57  SPECIALDEVICE=""
57  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61  #  DIALOG BOXEN #  # -> now in images.conf
62  #################################################  CDIMAGENAME=""
63    TOTALLINES=""
64    CURRENTLINE=0
65    if [ -e ${IMAGEROOT}/images.conf ]
66    then
67     source ${IMAGEROOT}/images.conf
68     # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71    else
72     die "${IMAGEROOT}/images.conf not found"
73    fi
74    
75    ### helper scripts ###
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 86  trap_exit() Line 86  trap_exit()
86   exit 1   exit 1
87  }  }
88    
 dialog_die()  
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"  
 }  
   
 dialog_setup_system_menu()  
 {  
  local mode  
  local retval  
   
  mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \  
  $"1:Automatic setup (recommended)" \  
  ":" \  
  $":\Z1Expert modes:\Zn" \  
  $"2:Common IDE-disk (manual setup)")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case "${mode}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n \\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"  
  fi  
   
  messagebox -y 15 -h $"Detected hardware:" "${message}"  
 }  
   
 dialog_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manual  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
89  install_meter()  install_meter()
90  {  {
91   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
# Line 246  install_meter() Line 99  install_meter()
99   return 0   return 0
100  }  }
101    
102  dialog_main()  mount_rootfs()
103  {  {
  local method=0  
104   local retval   local retval
105    
106   while [[ ${method} -le 2 ]]   if is_mounted --location "${INSTALLROOT}"
107   do   then
108   method=$(menubox $"Configuration:" \   echo $"${INSTALLROOT} already mounted" >&2
109   $"1:Install system" \   else
110   $"2:Show detected harddrives" \   mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
111   $"3:Exit and reboot" \   fi
112   $"4:Exit and drop into a shell")   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
113   retval=$?  }
114   [[ ${retval} -eq 1 ]] && exit 1  
115   if [[ ${retval} -eq 0 ]]  umount_rootfs()
116   then  {
117   case ${method} in   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
118   "1") dialog_setup_system_menu ;;   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
119   "2") dialog_hardware_detection ;;  }
120   "3") install_do_reboot ;;  
121   "4") /bin/bash --login -i ;;  install_do_reboot()
122   esac  {
123   fi   reboot
  done  
124  }  }
125    
 #################################################  
 # Install Komandos #  
 #################################################  
126  run_hardware_detection()  run_hardware_detection()
127  {  {
128   local hwinfo   local hwinfo
129    
130   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
131    
132   ## check for special devices/clients:   # check for special devices/clients:
133   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
134   #local removable=0   local removable=0
135   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
136   #then   then
137   #for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
138   #do   #do
139   #if [[ $(< ${i}) = 1 ]]   # if [[ $(< ${i}) = 1 ]]
140   #then   # then
141   #removable=1   # removable=1
142   #fi   # fi
143   #done   #done
144   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
145    
146   ## only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
147   #export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
148   ## there are to zotac types in the wild, nvidia based gfx and intel   # there are to zotac types in the wild, nvidia based gfx and intel
149   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
150   #then   then
151   #export SPECIALDEVICE="zotac_nvidia"   export SPECIALDEVICE="zotac_nvidia"
152   #else   else
153   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_intel"
154   #fi   fi
155   #fi   fi
156    
157   # check for special devices/clients:   # check for special devices/clients:
158   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 340  run_hardware_detection_disks() Line 188  run_hardware_detection_disks()
188   # all disks but exclude ramdisks   # all disks but exclude ramdisks
189   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
190   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
191   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
192   then   then
193   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
194   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
195   fi   fi
196   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
197  }  }
198    
 hdd_size_below_256mb()  
 {  
  local hdd="$1"  
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
   
  size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')  
  if [[ ${size} -le 257000000 ]]  
  then  
  retval="0"  
  else  
  retval="1"  
  fi  
   
  return "${retval}"  
 }  
   
199  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
200  {  {
201   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
# Line 380  setup_hdd_partitions_auto() Line 210  setup_hdd_partitions_auto()
210   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
211   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
212   then   then
213   if hdd_size_below_256mb ${HDD}   if device_minimum_size "${HDD}" 256
214   then   then
215   FDISKPARTIONBELOW256MB=1   FDISKPARTIONBELOW256MB=1
216   else   else
# Line 455  setup_hdd_format() Line 285  setup_hdd_format()
285   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
286  }  }
287    
 install_mount_rootfs()  
 {  
  is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
  install -d ${INSTALLROOT}/boot || dialog_die  
 }  
   
288  install_system_image()  install_system_image()
289  {  {
290   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
291   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${IMAGEROOT}}/${CDIMAGENAME} -C ${INSTALLROOT}
292   popd > /dev/null   popd > /dev/null
293  }  }
294    
295  install_bootsector_chroot()  install_system_settings()
296  {  {
297   local my_roothdd   local CONFIG
298   local grubconf=${INSTALLROOT}/boot/grub/grub.conf  
299   local grub2conf=/boot/grub/grub.cfg   # write fstab
300     CONFIG="${INSTALLROOT}/etc/fstab"
301     clearconfig
302     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
303     addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
304     addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
305    
306   # check for grub2   # install network config skeleton
307   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
308     clearconfig
309     addconfig 'ONBOOT="yes"'
310     addconfig 'NETWORKING="dhcp"'
311    
312     # intel framebuffer quirk
313     CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
314     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
315   then   then
316   # needed by grub-mkconfig on the first run   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
  if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]  
317   then   then
318   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
319     [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
320   fi   fi
321     fi
322    }
323    
  # set kernelopts  
  if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]  
  then  
  sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  else  
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
324    
325   # grub-legacy  ### installer dialogs ###
  else  
  ### grubconf schreiben  
  source ${INSTALLROOT}/boot/kernelversion  
326    
327   #for alx only  dialog_die()
328   if [ -e ${INSTALLROOT}/etc/alx_version ]  {
329   then   ERROR="$1"
330   OLD_ALXVER="${ALXVER}"   RETVAL="$?"
331   source ${INSTALLROOT}/etc/alx_version   dialog_install_failure
332   KRNVER="ALX-${ALXVER}"   exit 1
333   ALXVER="${OLD_ALXVER}"  }
  fi  
334    
335   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  dialog_warning()
336   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  {
337   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"   local retval
338    
339   # uuid support   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
340   if is_uuid_supported   retval=$?
341   then   if [[ ${retval} -eq 1 ]]
342   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"   then
343   else   clear
344   my_roothdd="${ROOTHDD}"   echo $"The process was aborted."
345   fi   exit 1
346     fi
347    }
348    
  : > ${grubconf} || dialog_die  
  echo "default 0" >> ${grubconf} || dialog_die  
  echo "timeout 3" >> ${grubconf} || dialog_die  
  # using current root password  
  echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die  
   
  echo  >> ${grubconf} || dialog_die  
  echo "# normal boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER}" >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
349    
350   echo >> ${grubconf} || dialog_die  ### installer tasks ###
  echo "# admin boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die  
  echo "lock"  >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
351    
352   echo >> ${grubconf} || dialog_die  task_setup_system_menu()
353   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die  {
354   echo "lock"  >> ${grubconf} || dialog_die   local mode
355   echo "root (hd0,0)" >> ${grubconf} || dialog_die   local retval
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
356    
357   # bootsector schreiben chrooted schreiben (lfs/magellan)   mode="$(dialog_setup_system_menu)"
358   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   retval=$?
359  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   [[ ${retval} -eq 1 ]] && return 1
360  root (hd0,0)   if [[ ${retval} -eq 0 ]]
361  setup (hd0)   then
362  quit   case "${mode}" in
363  EOF   "1") run_install_auto ;;
364  exit 0   "2") run_install_normal ;;
365  CHROOTEOF   "") task_setup_system_menu;;
366     esac
367   fi   fi
   
  # run installrc  
  chrooted /bin/bash --rcfile /root/.installrc -i  
  rm ${INSTALLROOT}/root/.installrc  
368  }  }
369    
370  is_initrd_supported()  task_hardware_detection()
371  {  {
372   # only generate initrds if the cmd exists   local message
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
373    
374  install_initrd_chroot()   run_hardware_detection_disks
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
375    
376   DISKMODS="sd_mod"   message+=$"Harddrives:\n"
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
377    
378   if [[ ${FORMFACTOR} = laptop ]]   if [[ ! -z ${ALL_DISKS} ]]
379   then   then
380   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   for i in ${ALL_DISKS}
381     do
382     message+="\Z3${i}\Zn "
383     done
384     message+="\n"
385   fi   fi
386    
387   # install an appropriate uvesafb.conf   if [[ ! -z ${ALL_CDROMS} ]]
388   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die   then
389   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die   message+="\n"
390     message+=$"Optical disk drives:\n"
391   # install an appropriate viafb.conf   for i in ${ALL_CDROMS}
392   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die   do
393     message+="\Z3${i}\Zn"
394   # install an appropriate i810fb.conf   done
395   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die   message+="\n"
396     fi
397    
398   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   # other devices
399  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd   run_hardware_detection
400  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null   case "${SPECIALDEVICE}" in
401  exit 0   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
402  CHROOTEOF   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
403     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
404     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
405     esac
406     if [[ ${FORMFACTOR} = laptop ]]
407     then
408     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
409     fi
410    
411   # run installrc   messagebox -y 12 -h $"Detected hardware:" "${message}"
  chrooted /bin/bash --rcfile /root/.installrc -i  
  rm ${INSTALLROOT}/root/.installrc  
412  }  }
413    
414  is_uuid_supported()  task_setup_hdd_partitions_manual()
415  {  {
416   if [[ -x $(type -P busybox.mkinitrd) ]]   local i
417     local retval
418    
419     if [[ -z ${ALL_DISKS} ]]
420   then   then
421   # only detect uuids if supported   dialog_no_harddrive_found
422   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   exit 1
423     else
424     HDD=$(dialog_select_target_harddrive)
425     retval=$?
426     [[ ${retval} -eq 1 ]] && return 1
427     if [[ ${retval} -eq 0 ]]
428   then   then
429   return 0   dialog_setup_hdd_info
430     setup_hdd_partitions_manual
431   fi   fi
432   fi   fi
   
  return 1  
433  }  }
434    
435  install_system_settings()  task_setup_hdd_partitions_auto()
436  {  {
437   # schreibe fstab   local i
438   if is_uuid_supported   local retval
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
   
  # install network config skeleton  
  install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die  
439    
440   # intel framebufer quirk   if [[ -z ${ALL_DISKS} ]]
  if [[ -e /proc/fb ]]  
441   then   then
442   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   dialog_no_harddrive_found
443     exit 1
444     else
445     HDD=$(dialog_select_target_harddrive)
446     retval=$?
447     [[ ${retval} -eq 1 ]] && return 1
448     if [[ ${retval} -eq 0 ]]
449   then   then
450   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   dialog_setup_hdd_info_auto
451   if [[ ${fbdev} != 0 ]]   dialog_setup_hdd_create_partitions
452   then   setup_hdd_partitions_auto
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
453   fi   fi
454   fi   fi
455  }  }
456    
457  install_umount_rootfs()  task_main()
458  {  {
459   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   local method=0
460   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   local retval
 }  
461    
462  install_do_reboot()   while [[ ${method} -le 2 ]]
463  {   do
464   reboot   method=$(dialog_main)
465     retval=$?
466     [[ ${retval} -eq 1 ]] && exit 1
467     if [[ ${retval} -eq 0 ]]
468     then
469     case ${method} in
470     "1") task_setup_system_menu ;;
471     "2") task_hardware_detection ;;
472     "3") install_do_reboot ;;
473     "4") /bin/bash --login -i ;;
474     esac
475     fi
476     done
477  }  }
478    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
   
479  run_install_normal()  run_install_normal()
480  {  {
481   dialog_hardware_detection   task_hardware_detection
482    
483   dialog_setup_hdd_partitions_manual   task_setup_hdd_partitions_manual
484   dialog_setup_hdd_format   dialog_setup_hdd_format
485   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
486   install_mount_rootfs   mount_rootfs
487   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
488    
489   dialog_install_settings   dialog_install_settings
490   sleep 1   sleep 1
491   install_system_settings   install_system_settings
492   dialog_install_initrd   if is_initrd_supported
493   install_initrd_chroot   then
494     dialog_install_initrd
495     initrd_config
496     initrd_install
497     fi
498    
499   dialog_install_bootsector   dialog_install_bootsector
500   install_bootsector_chroot   bootloader_config
501     bootloader_install
502    
503   install_umount_rootfs   umount_rootfs
504   dialog_install_successful   dialog_install_successful
505  }  }
506    
507  run_install_auto()  run_install_auto()
508  {  {
509   dialog_hardware_detection   task_hardware_detection
510    
511   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
512   dialog_setup_hdd_format   dialog_setup_hdd_format
513   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
514   install_mount_rootfs   mount_rootfs
515   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
516    
517   dialog_install_settings   dialog_install_settings
518   sleep 1   sleep 1
519   install_system_settings   install_system_settings
520   dialog_install_initrd   if is_initrd_supported
521   install_initrd_chroot   then
522     dialog_install_initrd
523     initrd_config
524     initrd_install
525     fi
526    
527   dialog_install_bootsector   dialog_install_bootsector
528   install_bootsector_chroot   bootloader_config
529     bootloader_install
530    
531   install_umount_rootfs   umount_rootfs
532   dialog_install_successful   dialog_install_successful
533  }  }
534    
535  # set some proper traps  # set some proper traps
536  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
537    
538  dialog_main  task_main
539    
540  exit 0  exit 0

Legend:
Removed from v.2438  
changed lines
  Added in v.2654